LIBRARY IEEE;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.all;
library ieee_proposed;
use ieee_proposed.fixed_float_types.all;
use ieee_proposed.float_pkg.all;


ENTITY testbench_factn is
END testbench_factn;

ARCHITECTURE behavior of testbench_factn is
  component factn
  generic(
    we:positive;
    wf: positive
    );
  port(
    n: in integer range 0 to 15;
    data: out float(we downto -wf)
    );
        
  end component;
      
  --Inputs
  constant we:positive:=3;
  constant wf:positive:=4;
 
  
  
  signal data: float(we downto -wf):=to_float(0.0,we,wf);
  signal n:integer range 0 to 15:=0;
  
  begin
          
          
  factn_0: factn
      generic map(
        we=>we,
        wf=>wf
      )
      port map(
        n=>n,
        data=>data
        );

    
    
    tb: process
      begin
        
        wait for 25 ns;
        for i in 0 to 15 loop
          n<=i;
          wait for 25 ns;
        end loop;
        wait for 100 ns;
        
      end process;
  
  end;
  
